#include "Best.h"


/////constructor.
CBest ::CBest(int number)
{
    int i,j,k;
    labelNum=number;
    m=1;

	for (i=0;i<=labelNum;i++)
	  for (j=0;j<=labelNum;j++)
	    for (k=0;k<=labelNum;k++)
	    {
			bucket_xy[i][j][k].left = new CLabelSet(number+1);
			bucket_xy[i][j][k].right = new CLabelSet(number+1);
			(bucket_xy[i][j][k]).delta=-1;
			(bucket_xy[i][j][k]).quartet_error=-1;
			(bucket_xy[i][j][k]).next=0;
         }

    for (i=0;i<=labelNum;i++)
	{
		bucket_Qk[i].left = new CLabelSet(number+1);
	 	bucket_Qk[i].right = new CLabelSet(number+1);
	 	(bucket_Qk[i]).delta=-1;
	 	(bucket_Qk[i]).quartet_error=-1;
	 	(bucket_Qk[i]).next=0;
	 }

     quartetTable= new CQuartetTable(labelNum);

     head_all= (struct Partition *) calloc(1, sizeof(struct Partition ));
	 head_all->delta=88888;
	 head_all->quartet_error=88888;
	 head_all->next=0;

     head_compatible= (struct Partition *) calloc(1, sizeof(struct Partition ));
	 head_compatible->delta=88888;
	 head_compatible->quartet_error=88888;
	 head_compatible->next=0;

     edges=(int*) calloc(2*labelNum,sizeof(int));
     
     ///n leaft nodes 1..n
     // n-2 internal nodes  n+1..2n-2
     /// root label is 2n-1
     /// allocate 2n-1 memory, 1...2n-2, don't care root.

}
/// de-constructor
CBest ::~CBest()
{
}


////set the m value for hyper cleaning
void CBest ::Setm(int number)
{
	m=number;
}


void CBest ::Initialize()
{
	CLabelSet *left , *right;

	left = new CLabelSet(4);
	right= new CLabelSet(4);
	left->Add(1);
	right->Add(2);
	right->Add(3);
	AddPartition_Qk(3, left, right, 0);
    delete left;
	delete right;

    left = new CLabelSet(4);
	right= new CLabelSet(4);
	left->Add(2);
	right->Add(1);
	right->Add(3);
	AddPartition_Qk(3, left, right, 0);
    delete left;
	delete right;

    left = new CLabelSet(4);
	right= new CLabelSet(4);
	left->Add(3);
	right->Add(1);
	right->Add(2);
	AddPartition_Qk(3, left, right, 0);
    delete left;
	delete right;
}

void CBest ::Best_Qk()
{
   
   UNSIGNCHAR edge_num,k;

   Best_xy();

   Initialize();
       
   for (k=4;k<=labelNum;k++)
      Best_Qk(k, m);
      
   Sort(labelNum);
 
   edge_num=GenerateCompatibleEdges();

  // Display(head_compatible);
//Display(head_all);

  // if (edge_num!=labelNum-3)
    //  printf("%d Edges are not enough to form a tree!\n",edge_num);
//   GenerateTree(head_compatible);
 //  OuptPutTree("outtree.txt");
   
}

void CBest::GetAllCandidateEdges( struct Partition * edgelist)
{
	struct Partition *CurrentPartition;
	int i=0;

//printf("in\n");
//	   Display(head_compatible);
	   
	   
	   
    CurrentPartition=head_compatible->next;
   
	while (CurrentPartition !=0)
	{
        edgelist[i].delta=CurrentPartition->delta;
  //      printf("size=%d",CurrentPartition->left->GetSize());
        
        edgelist[i].left->Copy(CurrentPartition->left);
        edgelist[i].quartet_error=CurrentPartition->quartet_error;
        edgelist[i].chosen=CurrentPartition->chosen;
	    CurrentPartition=CurrentPartition->next;
		i++;

	}

    
    
}



void CBest ::Best_Qk( UNSIGNCHAR k, int m)
{
    CLabelSet *left1,  *right1;
    struct Partition *CurrentPartition;
    int error;
    int x;
    int prev;//,count=0;

    left1= new CLabelSet(labelNum+1);
    right1= new CLabelSet(labelNum+1);

    //// get the head of best_xy_(k-1)
    CurrentPartition = & (bucket_Qk[k-1]);

    while (CurrentPartition !=0)
    {
	    left1->Copy(CurrentPartition->left);
        left1->Add(k);
        error=CheckDelta_Qk(0,left1, CurrentPartition->right, k, m,CurrentPartition->quartet_error);
        if (error>=0)
        {
           AddPartition_Qk(k, left1, CurrentPartition->right, error);
           //count++;
	   }

        right1->Copy(CurrentPartition->right);
        right1->Add(k);
	    error = CheckDelta_Qk(1,CurrentPartition->left, right1, k, m, CurrentPartition->quartet_error);
        if (error>=0)
        {
           AddPartition_Qk( k, CurrentPartition->left, right1, error);
          // count++;
	    }
	    CurrentPartition= CurrentPartition->next;
     }

//printf("k=%d,count=%d\n",k,count);
	 for (x=1;x<k;x++)
	 {
		 ///////
		 if (x==k-1)
		   prev=k-2;
		 else
		   prev=k-1;

		 CurrentPartition = & (bucket_xy[x][k][prev]);
		 while (CurrentPartition !=0)
         {
	         if ( PartitionGenerated(CurrentPartition,k)==0)
	         {
				 error=CheckDelta_Qk(CurrentPartition->left, CurrentPartition->right, m);
	             if (error>=0)
	             {
	               AddPartition_Qk(k, CurrentPartition->left, CurrentPartition->right, error);
	              // count++;
			     }
			 }
            CurrentPartition= CurrentPartition->next;
	     }
	 }

}

int CBest ::PartitionGenerated(struct Partition *QueryPartition, int k)
{
    struct Partition *CurrentPartition;

    CurrentPartition = & (bucket_Qk[k]);
    while (CurrentPartition !=0)
    {
		if ( (QueryPartition->left->Equal(CurrentPartition->left) )||
		     (QueryPartition->left->Equal(CurrentPartition->right)) )
		    return 1;

		CurrentPartition=CurrentPartition->next;
	}
	return 0;
}


int CBest ::CheckDelta_Qk(CLabelSet *left, CLabelSet *right, int m)
{
   int error=0;
   UNSIGNCHAR quartet[4];
   UNSIGNCHAR i,j,k,l,a,b,c,d;
   int  size_l, size_r;

    size_l=left->GetSize();
    size_r=right->GetSize();

    for (i=0;i<size_l-1;i++)
      for (j=i+1;j<size_l;j++)
      {
		  a=left->Pop(i);
		  b=left->Pop(j);
		  for (k=0;k<size_r-1;k++)
            for (l=k+1;l<size_r;l++)
            {
				c=right->Pop(k);
		        d=right->Pop(l);
		        quartetTable->formquartet(a,b,c,d,quartet);
				if (quartetTable->find(quartet)==0)
			       error++;
		    }
       }

	if (error> m * (size_l-1) * (size_r-1)/2)
		 return -1;
	else
		return error;
}


int CBest ::CheckDelta_Qk_CountError(CLabelSet *labelSet1, CLabelSet *labelSet2, UNSIGNCHAR  size1, UNSIGNCHAR size2, int s_k)
{
    UNSIGNCHAR i,j,k, quartet[4], label1, label2[2];

    int error=0;
	for (i=0;i<size1;i++)
	{
        ////get one label from left side
        label1=labelSet1->Pop(i);
		
    	/// get two labels from right
        if (label1==s_k) continue;
        
        for (j=0;j<size2-1;j++)
           for (k=j+1;k<size2;k++)
           {
                label2[0]= labelSet2->Pop(j);
                label2[1]= labelSet2->Pop(k);                       
                quartetTable->formquartet(label1,s_k,label2[0],label2[1],quartet);
        	   	if (quartetTable->find(quartet)==0)
				       error++;
		  }
	}
	return error;
}

int CBest ::CheckDelta_Qk(int pos_k, CLabelSet *left, CLabelSet *right, int k, int m, int error_k1)
{
	int error=0;

	UNSIGNCHAR size_l, size_r;

	size_l=left->GetSize();
    size_r=right->GetSize();

    if (pos_k==0) /// s_k is in left side.
      error =CheckDelta_Qk_CountError(left, right, size_l, size_r,  k);
	else ///s_k is in the right side
      error =CheckDelta_Qk_CountError(right, left, size_r, size_l,  k);
    
   	//printf("error_k1=%d, error=%d, m=%d\n",error_k1, error,m);
	if (error_k1+error> m * (size_l-1) * (size_r-1)/2)
	   return -1;
	else
	  return error_k1+error;
}


void CBest ::AddPartition_Qk(int k, CLabelSet *left, CLabelSet *right, int error)
{
	struct Partition * par;
	float delta;
    UNSIGNCHAR size_l, size_r;

    size_l=left->GetSize();
    size_r=right->GetSize();

    if ( (size_l==1) || (size_r==1) )
      delta=0;
    else
      delta = (error*4.0)/(size_l*(size_l-1)*size_r*(size_r-1));

    if (bucket_Qk[k].delta<0)
	{
		bucket_Qk[k].left->Copy(left);
		bucket_Qk[k].right->Copy(right);

		bucket_Qk[k].delta=delta;
		bucket_Qk[k].quartet_error=error;
	}
	else
	{
		par= (struct Partition *) calloc(1, sizeof(struct Partition ));
		par->left = new CLabelSet(labelNum+1);
		par->right= new CLabelSet(labelNum+1);
		(par->left)->Copy(left);
	    (par->right)->Copy(right);
		par->delta=delta;
		par->quartet_error=error;
		par->next =	bucket_Qk[k].next;
		bucket_Qk[k].next=par;
	}

}


void CBest ::Sort(int k)
{
	struct Partition *CurrentPartition, *tmp,*par;

	int eq=0, size_l, size_r;

	CurrentPartition = & (bucket_Qk[k]);

	//printf("k=%d:\n",k);
    while (CurrentPartition !=0)
    {
		size_l=CurrentPartition->left->GetSize();
		size_r=CurrentPartition->right->GetSize();
		if ((size_l==1) ||(size_r==1) ) //// discard size 1 edges
		{
			CurrentPartition=CurrentPartition->next;
			continue;
		}

      par= (struct Partition *) calloc(1, sizeof(struct Partition ));
      par->left = new CLabelSet(labelNum+1);
      par->right= new CLabelSet(labelNum+1);
      ///make sure the left part has smaller labels
      if (size_l<=size_r)
      {
            
            (par->left)->Copy(CurrentPartition->left);
            (par->right)->Copy(CurrentPartition->right);
      }
      else
      {
                      
            (par->left)->Copy(CurrentPartition->right);
            (par->right)->Copy(CurrentPartition->left);
      }
      par->delta=CurrentPartition->delta;
      par->quartet_error=CurrentPartition->quartet_error;
      par->m_value = (CurrentPartition->delta*size_l*size_r/2);
      
      /// find the location
      tmp=head_all;
      while (tmp->next!=0)   ////firt delta
      {
	   if (par->delta >tmp->next->delta)
	     tmp= tmp->next;
	   else
	   {
	     if (par->delta==tmp->next->delta)
	       eq=1;
	     else
	      eq=0;
	    break;
	   }
	   }

	   if (eq==1)  //// if delta equals, compare the quartet errors
	   {
	      while (tmp->next!=0)
	      {
	        if (par->quartet_error > tmp->next->quartet_error)
		    	tmp= tmp->next;
		    else
		       break;
          }
	 }
	 par->next=tmp->next;
	 tmp->next=par;
	 CurrentPartition=CurrentPartition->next;
	}
}



void CBest ::Display(struct Partition * head)
{
	struct Partition *CurrentPartition;
	int count=0;
	double m_value;
    UNSIGNCHAR size_l, size_r;
	CurrentPartition=head->next;


	while (CurrentPartition !=0)
	{
		CurrentPartition->left->Display();
		CurrentPartition->right->Display();
		size_l=CurrentPartition->left->GetSize();
		size_r=CurrentPartition->right->GetSize();
		m_value = (CurrentPartition->delta*size_l*size_r/2);

		printf(" m=%.2f, delta=%.2f, error=%d",m_value,CurrentPartition->delta,CurrentPartition->quartet_error);

	printf("(%d, %d, %d):%d\n",
               ConflictCount(CurrentPartition->left,CurrentPartition->right ),
               NonexchangeableCount(CurrentPartition->left,CurrentPartition->right ),
               NonexchangeableCount(CurrentPartition->right,CurrentPartition->left ),
               CurrentPartition->chosen);
               
               
	//	ec->UnexchangeableCount(CurrentPartition->left, CurrentPartition->right);

		CurrentPartition=CurrentPartition->next;
		count++;
	}
    printf("total %d edges\n", count);
 }
/*
 void CBest ::GenerateTree(struct Partition * head)
 {
     struct Partition *CurrentPartition;
     int count=0;
     double m_value;
     UNSIGNCHAR size_l, size_r;
     int m_count[20];
     int i,error=0;
     CQuartetTable  *quartetTable1= new CQuartetTable(labelNum);
     UNSIGNCHAR label_left[2], label_right[2];
     UNSIGNCHAR quartet[4];


     CurrentPartition=head->next;
     for (i=0;i<20;i++)
        m_count[i]=0;
     while (CurrentPartition !=0)
     {
     	CurrentPartition->left->Display();
        CurrentPartition->right->Display();
        size_l=CurrentPartition->left->GetSize();
        size_r=CurrentPartition->right->GetSize();
        m_value = (CurrentPartition->delta*size_l*size_r/2);
        m_count[(int)ceil(m_value)]++;
       // printf(" m=%.2f, delta=%.2f, error=%d\n",m_value,CurrentPartition->delta,CurrentPartition->quartet_error);

		CurrentPartition->left->Init();
		while ( CurrentPartition->left->PopTwo(label_left)>0)
		{
			CurrentPartition->right->Init();
		   	while ( CurrentPartition->right->PopTwo(label_right)>0)
		    {
				quartetTable1->formquartet(label_left[0],label_left[1],label_right[0],label_right[1],quartet);

		    	if (quartetTable1->find(quartet)==0)
		    	{
					quartetTable1->Insert(quartet,1);
					if (quartetTable->find(quartet)==0)
				       error++;
				}
			}
		}

        CurrentPartition=CurrentPartition->next;
        count++;

     }
     printf("total %d edges. quartet errors: %d\n", count,error);
     for (i=0;i<20;i++)
       if (m_count[i]>0)
          printf("m=%d, count %d\n",i, m_count[i]);
 }

*/
 
UNSIGNCHAR CBest :: GenerateRandom(UNSIGNCHAR *labels, UNSIGNCHAR size, UNSIGNCHAR internalIndex)
{
    UNSIGNCHAR i, x1,x2,y, index;
    index=internalIndex;
    
   /*     for (int i=0;i<size;i++)
    	printf("%d, ", labels[i]);
    	printf("\n");
    */
    srand((unsigned)time(NULL));
	y=size;
	while (y>=2)
	{
		x1=rand()%y;
		x2=rand()%y;
		while(x1==x2)
		   x2=rand()%y;
        
       // printf("merge (%d, %d) to %d\n", labels[x1],labels[x2], index);
        edges[labels[x1]]=index;
        edges[labels[x2]]=index;
        labels[x1]=index;
		if (x2<y-1)
		 labels[x2]=labels[y-1];
		y--;
		index++;
	}
	return index;
}
 
int CBest ::Check()
{ 
    UNSIGNCHAR i,j,k,l,lca_i,lca_j,q[4];
    int min_ijkl,min_ikjl;
    CQuartetTable *newTable = new CQuartetTable(labelNum);
     
    ultrametricMatrix = (int **)malloc((labelNum +1)*sizeof(int*) );
    for (i=1;i<=labelNum;i++)
      ultrametricMatrix[i]=(int *)calloc(labelNum +1, sizeof (int));
      
    for (i=1;i<labelNum;i++)
      for (j=i+1;j<=labelNum;j++)
      {
            lca_i=edges[i];
            
            while (lca_i>0)
            {
               lca_j=edges[j];
               while ( (lca_i!=lca_j) && (lca_j>0) )
                  lca_j=edges[lca_j];
               if  (lca_i==lca_j) 
               {
                  ultrametricMatrix[i][j]=lca_j;
                  break;  
                }
                else
                  lca_i=edges[lca_i];
                
            }
      }

     for (i=1;i<=labelNum-3;i++)
        for (j=i+1;j<=labelNum-2;j++)
          for (k=i+1;k<=labelNum-1;k++)
            for (l=k+1;l<=labelNum;l++)
            {
                if (ultrametricMatrix[i][j]>ultrametricMatrix[k][l])
                     min_ijkl=ultrametricMatrix[k][l];
                else  
                     min_ijkl=ultrametricMatrix[i][j];
                     
                if (ultrametricMatrix[i][k]>ultrametricMatrix[j][l])
                     min_ikjl=ultrametricMatrix[j][l];
                else  
                     min_ikjl=ultrametricMatrix[i][k];
               
                if (min_ikjl>min_ijkl)
                {
                    q[0]=i; q[1]=j; q[2]=k; q[3]=l;
                }
                else if (min_ikjl<min_ijkl)
                {
                    q[0]=i; q[1]=k; q[2]=j; q[3]=l;
                }
                else
                {

                    q[0]=i; q[1]=l; q[2]=j; q[3]=k;
                }
                
                newTable->Insert(q,1);
                ///ij|kl, ik|jl il|jk
            }
            newTable->save("newquartets.txt");
            return quartetTable->Compare(newTable);

} 
void CBest ::GenerateTree(struct Partition * head)
{
     struct Partition *currentPartition, *partition;
     UNSIGNCHAR size_l, size_r, tmp_size,i,j;
     CLabelSet * tmp_labelset;
   
     UNSIGNCHAR internalIndex=0, label1,label2, *nonMergeList;
     int label1Pos, label2Pos;
     
     nonMergeList =(UNSIGNCHAR *)  calloc(labelNum,sizeof(int));

    currentPartition=head->next;
    internalIndex=labelNum+1; /// the internal node index
    

    
    
    while (currentPartition !=0)
    {
        size_l=currentPartition->left->GetSize();
        if (size_l!=2) 
        {
          printf("resolve\n") ;
          currentPartition->left->Display();
          printf("\n") ;
          
          currentPartition->left->GetLabels(nonMergeList);
          internalIndex=GenerateRandom( nonMergeList, size_l, internalIndex);
          partition =  currentPartition->next;
          while (partition !=0)  
          {
                if (partition->left->Subset(currentPartition->left) )
                {
                    partition->left->Substract(currentPartition->left);
                    partition->left->Add(internalIndex);
                }                  
                partition=partition->next;
          }

        }
        else
        {
            label1=currentPartition->left->Pop(0);
            label2=currentPartition->left->Pop(1);  
            edges[label1]=internalIndex;
            edges[label2]=internalIndex; 
            //printf("merge (%d, %d) to %d\n", label1,label2, internalIndex);
            partition =  currentPartition->next;
            while (partition !=0)     
            {
                label1Pos= partition->left->In(label1); 
                label2Pos= partition->left->In(label2); 
              // printf("pos1=%d, pos2=%d\n",label1Pos,label1Pos); 
                if ((label1Pos>=0)&&(label2Pos>=0))
                {
                   partition->left->Delete(label1Pos, label2Pos);
                   partition->left->Add(internalIndex);
                }
                partition=partition->next;  
            }
             
        }
        currentPartition=currentPartition->next;
        internalIndex++;
    }
   // edges[2*labelNum-4]=2*labelNum-2;
    //edges[2*labelNum-3]=2*labelNum-2;
    
    //printf("internalIndex=%d\n",internalIndex);
    
    
    //if (internalIndex<2*labelNum-1)
    //{
        j=0;
        for (i=1;i<internalIndex;i++)
           if (edges[i]==0)
             nonMergeList[j++]=i;
    
           internalIndex=GenerateRandom(nonMergeList, j,  internalIndex);
    
    //}
    
      // printf("internalIndex=%d\n",internalIndex);
       
   /* for (int i=1;i<=2*labelNum-2;i++)
    	printf("(%d, %d) ",i, edges[i]);*/
    
}
void CBest ::OuptPutTree(char *filename)
{
     FILE *stream;
     int i,j=0;
     int rootlabels[2];
     if( (stream = fopen( filename, "w+t" )) == NULL )
     {
             printf( "ERROR! Write Tree to %s\n", filename );
             return;
     }
     else
          printf( "Writing Tree to %s\n", filename );

     fprintf(stream,"*Vertices,%d\n",2*labelNum-2);
     for (i=1;i<=labelNum;i++)
         fprintf(stream,"%d \"%s\"\n",i,quartetTable->GetLabelName(i));

     for (i=labelNum+1;i<=2*labelNum-2;i++)
         fprintf(stream,"%d \" \"\n",i);
         
     //fprintf(stream,"%d \"root\"\n",i);
     
     fprintf(stream,"\n*Edges\n");
     
     for (i=1;i<=2*labelNum-2;i++)
        if (edges[i]==2*labelNum-1)
        {
           // printf("i=%d,",i);
            rootlabels[j++]=i;
        }
     // printf("  %d,%d\n",rootlabels[0],rootlabels[1]);

     
     for (i=1;i<=2*labelNum-2;i++)
     {
            if (edges[i]!=2*labelNum-1)
                fprintf(stream,"%d,%d,0\n",i,edges[i]);
     }
     fprintf(stream,"%d,%d,1\n",rootlabels[0],rootlabels[1]);
     fclose(stream);

}
/// the head_compatible is sorted by the size of left side labels
int CBest ::GenerateCompatibleEdges()
{
	struct Partition *CurrentPartition1, *CurrentPartition2,*par, *insertPos;
	CurrentPartition1 = head_all->next;
	int count=0;

   // printf("finding compatible edges....\n");
   // tail=head_compatible;

    while (CurrentPartition1 !=0)/// 1: candidate
    {

		CurrentPartition2 = head_compatible->next;/// 2: the generated list;

        insertPos= head_compatible;
		while (CurrentPartition2 !=0)
		{
			if ( (CurrentPartition1->left->Subset(CurrentPartition2->left))||
			     (CurrentPartition2->left->Subset(CurrentPartition1->left))||
			     (CurrentPartition1->left->Subset(CurrentPartition2->right))||
			     (CurrentPartition2->right->Subset(CurrentPartition1->left))||
			     (CurrentPartition1->right->Subset(CurrentPartition2->left))||
			     (CurrentPartition2->left->Subset(CurrentPartition1->right))||
			     (CurrentPartition1->right->Subset(CurrentPartition2->right))||
			     (CurrentPartition2->right->Subset(CurrentPartition1->right))
		       ) //// 1 is compatible with 2
		    {
		       /// 1: candidate, 2: the generated list;
               if (CurrentPartition1->left->GetSize() > CurrentPartition2->left->GetSize())
                  insertPos = CurrentPartition2;
		       
               CurrentPartition2 = CurrentPartition2 ->next;
   
            }
            else
		      break;
		 }
		 if (CurrentPartition2==0) /// compatible
		 {
             par= (struct Partition *) calloc(1, sizeof(struct Partition ));
             par->left = new CLabelSet(labelNum+1);
             par->right= new CLabelSet(labelNum+1);
             (par->left)->Copy(CurrentPartition1->left);
             (par->right)->Copy(CurrentPartition1->right);
             par->delta=CurrentPartition1->delta;
             par->quartet_error=CurrentPartition1->quartet_error;
		     par->left_nonexchangeable = NonexchangeableCount(CurrentPartition1->left, CurrentPartition1->right);
             par->right_nonexchangeable = NonexchangeableCount(CurrentPartition1->right, CurrentPartition1->left);
             par->next=insertPos->next;
             if (  (CurrentPartition1->left->GetSize()==3) ||(CurrentPartition1->left->GetSize()==4) )
                par->chosen=1;
             else par->chosen=0;
		     insertPos->next=par;
		     count++;
		 }
		 CurrentPartition1=CurrentPartition1->next;
	 }
	 return count;

}



//// for x,y, find Best_xy
void CBest ::Best_xy()
{
	UNSIGNCHAR x,y,k;
	Partition *par;
	UNSIGNCHAR init=1;

	for (x=1;x<labelNum;x++)
	  for (y=x+1;y<=labelNum;y++)
	  {
		  init=1;
	      for (k=1;k<=labelNum;k++)
	      {
			  if ((k==x) || (k==y) ) continue;
			  if (init)
			  {
				  bucket_xy[x][y][k].left->Add(x);
				  bucket_xy[x][y][k].left->Add(k);
				  bucket_xy[x][y][k].right->Add(y);
				  bucket_xy[x][y][k].delta=0;
				  bucket_xy[x][y][k].quartet_error=0;

				  par= (struct Partition *) calloc(1, sizeof(struct Partition ));
				  par->left = new CLabelSet(labelNum+1);
				  par->right= new CLabelSet(labelNum+1);
				  (par->left)->Add(x);
				  (par->right)->Add(k);
				  (par->right)->Add(y);
				  bucket_xy[x][y][k].next=par;
				  init=0;
			  }
			  else
			  {
				  //printf("doing x=%d, y=%d, k=%d\n",x,y,k);
				  Best_xy(x, y, k, m);
			  }
		  }
	  }
	  //Display(1,2);
	 //Display(1,4);
}

//// we fix:  x<y ,  x in left side of partition, y in right side of partition

void CBest ::Best_xy(UNSIGNCHAR x, UNSIGNCHAR y, UNSIGNCHAR k, int m)
{
   CLabelSet *left1,  *right1;
   struct Partition *CurrentPartition;
   int error;

    left1= new CLabelSet(labelNum+1);
    right1= new CLabelSet(labelNum+1);

    //// get the head of best_xy_(k-1)

    int prev =k-1;

    while ( (prev==x) || (prev==y) )
      prev--;

    CurrentPartition = & (bucket_xy[x][y][prev]);

    while (CurrentPartition !=0)
    {

       left1->Copy(CurrentPartition->left);
	   left1->Add(k);
       error=CheckDelta_xy(x, y, 0, left1, CurrentPartition->right, k, m,CurrentPartition->quartet_error);
	   if (error>=0)
	      AddPartition_xy(x, y, k, left1, CurrentPartition->right, error);

		/*
		if((x==1)&&(y==4))
		{
		printf("x=%d,y=%d,k=%d,,error=%d,origerr=%d,prev=%d: ",x,y,k,error,CurrentPartition->quartet_error,prev);
		left1->Display();
		CurrentPartition->right->Display();
		printf("\n");
		getchar();
	   }

*/
       right1->Copy(CurrentPartition->right);
       right1->Add(k);
       error = CheckDelta_xy(x, y, 1, CurrentPartition->left, right1, k, m,CurrentPartition->quartet_error);
       if(error>=0)
         AddPartition_xy(x, y, k, CurrentPartition->left, right1, error);
/*
		if((x==1)&&(y==4))
		{
		printf("x=%d,y=%d,k=%d,error=%d,prev=%d,: ",x,y,k,error,prev);
		CurrentPartition->left->Display();
		right1->Display();
		printf("\n");
				getchar();
	   }*/

       CurrentPartition= CurrentPartition->next;
    }

    delete(left1);
    delete(right1);

     //AddPartition(k,sk, sk-1,0,0);
}



////pos_k: the position of s_k, 0: in the left side. 1: in the right side
//// we fix x is always in left side and y is always in right side

int CBest ::CheckDelta_xy(int x, int y, int pos_k, CLabelSet *left, CLabelSet *right, int k, int m, int error_k1)
{
	int error=0;
	UNSIGNCHAR quartet[4];
	UNSIGNCHAR  i, label, size;

	if (pos_k==0) /// s_k is in left side.
	{
        size=right->GetSize();
        for (i=0;i<size;i++)
	    {
           ////get one label from left side
           label=right->Pop(i);
	       if (label==y) continue;
           quartetTable->formquartet(x,k,y,label,quartet);
           if (quartetTable->find(quartet)==0)
			  error++;
        }
		  
	}
	else ///s_k is in the right side
	{
        
        size=left->GetSize();
        for (i=0;i<size;i++)
	    {
           ////get one label from left side
           label=left->Pop(i);
	       if (label==x) continue;
           quartetTable->formquartet(x,label,y,k,quartet);
           if (quartetTable->find(quartet)==0)
			  error++;
        }
		          
    }
	
	if (error_k1+error>m)
	   return -1;
	else
	  return error_k1+error;
	
}


void CBest ::AddPartition_xy(int x, int y, int k, CLabelSet *left, CLabelSet *right, int error)
{
	struct Partition * par;
	float delta;
    UNSIGNCHAR size_l, size_r;

    size_l=left->GetSize();
    size_r=right->GetSize();

    if ( (size_l==1) || (size_r==1) )
      delta=0;
    else
      delta = (error*4.0)/(size_l*(size_l-1)*size_r*(size_r-1));

    if (bucket_xy[x][y][k].delta<0)
	{
		//if (size_l<=size_r)   //// size of left partition is always less than that of the right partition
		{
			bucket_xy[x][y][k].left->Copy(left);
		    bucket_xy[x][y][k].right->Copy(right);
		}
		//else
		//{
		//	bucket_xy[x][y][k].right->Copy(left);
		//    bucket_xy[x][y][k].left->Copy(right);
		//}
		bucket_xy[x][y][k].delta=delta;
		bucket_xy[x][y][k].quartet_error=error;

		//printf("addd:");
		//left->Display();
		//bucket_xy[x][y][k].left->Display();

	}
	else
	{
		par= (struct Partition *) calloc(1, sizeof(struct Partition ));
		par->left = new CLabelSet(labelNum+1);
		par->right= new CLabelSet(labelNum+1);
		//if (size_l<=size_r)
		//{
			(par->left)->Copy(left);
		    (par->right)->Copy(right);
	   // }
	   /// else
	   // {
		//	(par->right)->Copy(left);
		//    (par->left)->Copy(right);
		//}
	    par->delta=delta;
		par->quartet_error=error;
		par->next =	bucket_xy[x][y][k].next;
		bucket_xy[x][y][k].next=par;
	}

}


void CBest ::Display(int x, int y)
{
	struct Partition *CurrentPartition;
	CurrentPartition = & (bucket_xy[x][y][labelNum]);

	printf("x=%d,y=%d, labelNum=%d ",x,y,labelNum);
    while (CurrentPartition !=0)
    {
		//printf("left:");
		CurrentPartition->left->Display();
		//printf("right:");
		CurrentPartition->right->Display();
		
		printf("%d\n",CurrentPartition->quartet_error);

		CurrentPartition=CurrentPartition->next;
    }
}

void CBest ::LoadFromFile(char *filename, UNSIGNCHAR inputformat)
{
    if (inputformat)
      quartetTable->LoadFromFile(filename);
    else
    {
      quartetTable->LoadFromDistanceMatrix(filename);
      quartetTable->GenerateQuartet_FourPoint();
      quartetTable->save("quartets.txt");
    }
}


int CBest ::ConflictCount(CLabelSet *left, CLabelSet *right)
{
	int error=0;
	UNSIGNCHAR quartet[4];
    unsigned char i,j,k,l,a,b,c,d;
    unsigned char  size_l, size_r;

	size_l=left->GetSize();
    size_r=right->GetSize();

    for (i=0;i<size_l-1;i++)
      for (j=i+1;j<size_l;j++)
      {
		  a=left->Pop(i);
		  b=left->Pop(j);
		  for (k=0;k<size_r-1;k++)
            for (l=k+1;l<size_r;l++)
            {
				c=right->Pop(k);
		        d=right->Pop(l);
		        quartetTable->formquartet(a,b,c,d,quartet);
			    if (quartetTable->find(quartet)!=1)
			       error++;
		    }
       }
    return error;
}

int CBest::NonexchangeableCount(CLabelSet *left, CLabelSet *right)
{
	char size_l=left->GetSize();
	char size_r=right->GetSize();
	char i,j,k,l,x,a,b,c,y,m;
	UNSIGNCHAR quartet[4],standard[4],compare[4];
	int  count=0;

	for (i=0;i<size_r-2;i++)
	{
		a=right->Pop(i);
		for (j=i+1;j<size_r-1;j++)
		{
			b=right->Pop(j);
			for (k=j+1;k<size_r;k++)
			{
				c=right->Pop(k);
				y=left->Pop(0);
				quartetTable->formquartet(y,a,b,c,quartet);
				quartetTable->find(quartet,standard);  ///first one.
				for (l=1;l<size_l;l++)
				{
					x=left->Pop(l);
					quartetTable->formquartet(x,a,b,c,quartet);
    				quartetTable->find(quartet,compare);

    				for (m=0;m<4;m++)
    				  if (compare[m]==x)
    				     break;
    				compare[m]=y;
    				quartetTable->formquartet(compare[0],compare[1],compare[2],compare[3],quartet);

					if (  (quartet[0]==standard[0])&& (quartet[1]==standard[1]) ) //||
					     //( (compare[0]==standard[2])&& (compare[1]==standard[3]) ) )
						   continue;
					else
					{
							count++;
							break;
					}
			    }///for l
			 }///for k
		 }//for j
	 }///for i

    //printf("total unexchangeable:%d\n",count);
	 return count;
}
