#ifndef __Best_H
#define __Best_H

#include "general.h"
/*#ifdef WINDOWS
#include "..\Common\LabelSet.h"
#include "..\Common\QuartetTable.h"
#else
#include "../Common/LabelSet.h"
#include "../Common/QuartetTable.h"
#endif
*/
#include "LabelSet.h"
#include "QuartetTable.h"

  struct Partition
  {
	  CLabelSet *left, *right;  //// left partition and right partition
	  float delta;             /// delta value
	  int   quartet_error;    /// number of inconsistent quartets
	  int   left_nonexchangeable, right_nonexchangeable; /// number of nonexchangeable set
	  float m_value;         /// m value
	  char  chosen;         
	  struct Partition* next;
  };
  


class CBest
{
    
private:
  
  //// in order to reduce the memory, we can change this structure.
  struct Partition bucket_xy[MAXILABEL][MAXILABEL][MAXILABEL], bucket_Qk[MAXILABEL];
//  struct Partition *head_all, *head_compatible;
   struct Partition *head_all;
  struct Partition *head_compatible;
  int labelNum;
  CQuartetTable *quartetTable;
  int *edges;
  int **ultrametricMatrix;
  int m;

public:
  CBest(int number);
  ~CBest();
  void Best_Qk();
  void Setm(int number);
  void LoadFromFile(char *filename, UNSIGNCHAR inputformat);
  void GetAllCandidateEdges( struct Partition * head);
  int  Check();

private:
  void Best_xy();
  void Best_xy(UNSIGNCHAR x, UNSIGNCHAR y, UNSIGNCHAR k, int m);
  int  CheckDelta_xy(int x, int y, int pos_k, CLabelSet *left, CLabelSet *right, int k, int m, int error_k1);
  void AddPartition_xy(int x, int y, int k,CLabelSet *left, CLabelSet *right, int error);
  void Display(int x, int y);
  void Best_Qk( UNSIGNCHAR k, int m);
  int  CheckDelta_Qk(int pos_k, CLabelSet *left, CLabelSet *right, int k, int m, int error_k1);
  int  CheckDelta_Qk_CountError(CLabelSet *labelSet1, CLabelSet *labelSet2, UNSIGNCHAR  size1, UNSIGNCHAR size2, int k);
  void AddPartition_Qk(int k, CLabelSet *left, CLabelSet *right, int error);
  void Initialize();
  void Display(struct Partition * head);
  void GenerateTree(struct Partition * head);
  void GeneratePartialTree(struct Partition * head);
  UNSIGNCHAR GenerateRandom(UNSIGNCHAR *labels, UNSIGNCHAR size, UNSIGNCHAR internalIndex);
  int  CheckDelta_Qk(CLabelSet *left, CLabelSet *right, int m);
  int  PartitionGenerated(struct Partition *QueryPartition, int k);
  void Sort(int k);
  int  GenerateCompatibleEdges();
  void OuptPutTree(char *filename);
  int  ConflictCount(CLabelSet *left, CLabelSet *right);
  int  NonexchangeableCount(CLabelSet *left, CLabelSet *right);
};
#endif
;


