#ifndef __BitLabelSet_H
#define __BitLabelSet_H

#include "general.h"

class CBitLabelSet
{
private:
    UNSIGNCHAR length;  /// the total length of the labelset
    UNSIGNCHAR size;    /// the number of elements in the set
    unsigned char *labels; /// the labels in the set.

    static const  unsigned char bitmask[8];
    static const  unsigned char sizeBuf[256];

public:

  CBitLabelSet(int number);
  CBitLabelSet();
  ~CBitLabelSet();
  
  void AllocMem(int number);


  /// return the number of labels in the set
   UNSIGNCHAR GetSize();
   
   void GetLabels(UNSIGNCHAR *out);
  //char GetLength();
  
    void Clear();

   /// >=0, the position of label in the set
   /// -1,  the label is not in the set;
   int  In(UNSIGNCHAR label);


  /// add a label into the set
  /// if sucessfule, return 1.
  /// if the label is already in the set, return 0.
  int Add(UNSIGNCHAR label);

///delete two labels based on the positions
  void Delete(UNSIGNCHAR pos1, UNSIGNCHAR pos2);

  /// copy the elements in labelSet1
  void Copy(CBitLabelSet *labelSet1);

  ///pop out the element at the position
 // UNSIGNCHAR Pop(int position);

  void Display();
  
  /// 0: labelSet1 != me
  ////1:  labelSet1 = me
  int Equal(CBitLabelSet * labelSet1);
  
  ///0: labelSet1 is not a subset of me
  ///1: labelSet1 is a subset of me
  int SubsetOf(CBitLabelSet * labelSet1);
  
  int Union(CBitLabelSet * labelSet1);
  int Substract(CBitLabelSet * labelSet1);
  unsigned char Pop(UNSIGNCHAR i);
};
/*
const  unsigned char CBitLabelSet::bitmask[8]= {0x01u,0x02u,0x04u,0x08u,0x10u,0x20u,0x40u,0x80u};
const  unsigned char CBitLabelSet::sizeBuf[256]={
0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3, 2, 3, 3, 4, 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3,
 4, 3, 4, 4, 5, 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 2, 3, 3, 4, 3, 4
, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5,
2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4,
 5, 4, 5, 5, 6, 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 1, 2, 2, 3, 2, 3
, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5,
 6, 5, 6, 6, 7, 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 3, 4, 4, 5, 4, 5
, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7,
4, 5, 5, 6, 5, 6, 6, 7, 5, 6, 6, 7, 6, 7, 7, 8};
*/
#endif
