#include "LabelSet.h"

CLabelSet ::CLabelSet(int number)
{
	labels = (UNSIGNCHAR *) calloc(number, sizeof(UNSIGNCHAR));
	length=number;
	size=0;
}

CLabelSet ::CLabelSet()
{
	labels = 0;
	length=0;
	size=0;
}

CLabelSet ::~CLabelSet()
{
	free(labels);
}

UNSIGNCHAR CLabelSet :: GetSize()
{
	return size;
}

void CLabelSet :: AllocMem(int number)
{
	labels = (UNSIGNCHAR *) calloc(number, sizeof(UNSIGNCHAR));
	length=number;
	size=0;

}

void CLabelSet :: GetLabels(UNSIGNCHAR *out)
{
    memcpy(out,labels,size);

}

/// return the position of label if in
/// else return -1
int CLabelSet ::In(UNSIGNCHAR label)
{
	int i;
	for (i=0;i<size;i++)
	   if (labels[i]==label)
	     return i;
	return -1;
}

//// add an element to the set. and size++
/// pls make sure no repeated element.
void CLabelSet ::Add(UNSIGNCHAR label)
{
	labels[size++]=label;
}


/// delete two labels based on their position
void CLabelSet ::Delete(UNSIGNCHAR pos1, UNSIGNCHAR pos2)
{
    UNSIGNCHAR small, big,i,j;
    if (pos1<pos2)
    {
      small=pos1;
      big=pos2;
    }
    else
    {
        small=pos2;
        big=pos1;
    }
    i=small; j=small+1;
    while (j<size)
    {
        if (j!=big)
        {
           labels[i]=labels[j];
           i++;
        }
        j++;
    }
    size-=2;
        
}

void CLabelSet ::Copy(CLabelSet *labelSet1)
{
	UNSIGNCHAR i;

   // memset(labels,0,length);
    size=labelSet1->GetSize();
   	for(i=0;i<size;i++)
	  labels[i]= labelSet1->Pop(i);
}


UNSIGNCHAR CLabelSet :: Pop(int position)
{
	return labels[position];

}

int CLabelSet ::Equal(CLabelSet * labelSet1)
{
	UNSIGNCHAR i;
	if (size!=labelSet1->GetSize())
	  return 0;
	for(i=0;i<size;i++)
	  if (In(labelSet1->Pop(i))<0)
        return 0;
    return 1;

}

// check whether labelSet1 is a subset of me
int CLabelSet ::Subset(CLabelSet * labelSet1)
{
	UNSIGNCHAR i, sizeLabelSet1;

    sizeLabelSet1=labelSet1->GetSize();
	if (size < sizeLabelSet1)  /// I am smaller 
	  return 0;

	for(i=0;i<sizeLabelSet1;i++)
	  if (In(labelSet1->Pop(i))<0)  /// found one not in my set
	    return 0;
    return 1;

}

///// add labelSet1 to me
int CLabelSet ::Union(CLabelSet * labelSet1)
{
	UNSIGNCHAR i, sizeLabelSet1;
	int label;

    sizeLabelSet1=labelSet1->GetSize();

    for(i=0;i<sizeLabelSet1;i++)
    {
        label=labelSet1->Pop(i);
        if (In(label)<0)
          labels[size++]=label;
    }
    return size;

}



// substract labelSet1 from me
//// {1,3,4,5}-{3,4}={1,5}
int CLabelSet ::Substract(CLabelSet * labelSet1)
{
	UNSIGNCHAR i,j, sizeLabelSet1;
	int pos;

    sizeLabelSet1=labelSet1->GetSize();

     
    for(i=0;i<sizeLabelSet1;i++)
    {
        pos = In(labelSet1->Pop(i));
        if (pos>=0)
        {
            for (j=pos;j<size-1;j++)
              labels[j]=labels[j+1];
            size--;
	    if (size==0) return 0;
	    //labels[j]=0;
        }
	
    }
    return size;
}


void CLabelSet :: Display()
{
	int i;
 	printf("{");
	for (i=0;i<size;i++)
	   printf("%d, ",labels[i]);
    printf("} ");

}

void CLabelSet :: Clear()
{
   size=0;
   //memset(labels,0,length);

}
