#ifndef __LabelSet_H
#define __LabelSet_H

#include "general.h"

class CLabelSet
{
private:
    UNSIGNCHAR length;  /// the total length of the labelset
    UNSIGNCHAR size;    /// the number of element in the set
    UNSIGNCHAR *labels; /// the labels in the set.

public:

  CLabelSet(int number);
  CLabelSet();
  ~CLabelSet();

  //// allocate memory. 
  /// if the used constructor is CLabelSet(), you should call it 
  /// to allocate memory
  void AllocMem(int number);

   /// return the number of labels in the set
   UNSIGNCHAR GetSize();

   void GetLabels(UNSIGNCHAR *out);
  //char GetLength();

   /// >=0, the position of label in the set
   /// -1,  the label is not in the set;
   int  In(UNSIGNCHAR label);


  /// add a label into the set
  void Add(UNSIGNCHAR label);

///delete two labels based on the positions
  void Delete(UNSIGNCHAR pos1, UNSIGNCHAR pos2);

  /// copy the elements in labelSet1
  void Copy(CLabelSet *labelSet1);

  ///pop out the element at the position
  UNSIGNCHAR Pop(int position);

  void Display();
  
  /// 0: labelSet1 != me
  ////1:  labelSet1 = me
  int Equal(CLabelSet * labelSet1);
  
  ///0: labelSet1 is not a subset of me
  ///1: labelSet1 is a subset of me
  int Subset(CLabelSet * labelSet1);
  
  int Union(CLabelSet * labelSet1);
  int Substract(CLabelSet * labelSet1);
  void Clear();
 
};
#endif


