#ifndef __PreProcessing_H
#define __PreProcessing_H

//#include "..\common\general.h"
/*
#ifdef WINDOWS
#include "..\Common\QuartetTable.h"
#include "..\hypercleaning\Best.h"
#else
#include "../Common/QuartetTable.h"
#include "../hypercleaning/Best.h"
#endif
*/

#include "general.h"
#include "QuartetTable.h"
#include "Best.h"

class CPreProcessing
{

private:
  int quartetNum, labelNum;
  int max_k;
  int totalConflicts;





  CQuartetTable *quartetTable;

  struct Conflict
  {
      UNSIGNCHAR q1[4],q2[4],q3[4];         //// the four labels of the quartet
      char fixed[3];
      char count;   /// number of fixed quartets + number of must_change quartets
      char change[2];
      int diff;
      struct Conflict* next;
  };
  struct Conflict *head, *tail, *conflictList, *conflict_head1,  *conflict_head2;

  //char ****must_change;
  //char **change_history;
  
  int  **conflictInclude, *conflictIncludeOne, **quartetsInvolved;
  int **errorUpperBound;
  int ** domain;

  int **childrenlist;
  int **ultra;
  int height[MAXILABEL];

int ****weightTable;
int max_height;

//int conflictNum[MAXILABEL][MAXILABEL][MAXILABEL][MAXILABEL];

int max_error;


 time_t   start, finish;
  double   elapsed_time;

CBest *best ;

public:

  CPreProcessing(int label_num, int k);

  ~CPreProcessing();

  /// load quartets from a file
  /// the number of labels should exist in at least one quartet.
  /// for example, if there are total 10 labels. then there should exist
  /// at least one quartet in which 10 is one of its label.
  void LoadFromFile(char *filename);
  void PreProcessing(char *filename);
  void resolve(int k);
  void SetStartTime(time_t t);

  void GenerateSmodelSource(char *filename);


private:
  void GenerateConflictList();
  int LowerBoundNotInclude(UNSIGNCHAR a, UNSIGNCHAR  b);
  void  DomainReduction();
  void  WriteQuartetRule(int a, int b, int c, int d, FILE *stream);
  
  int Compatible(UNSIGNCHAR q1[4],UNSIGNCHAR q2[4],UNSIGNCHAR q3[4]);
  int LabelExist(int label, int *list);
  void QuickSort(int *cost,  int low, int high);
  int ExchangeableCheck(UNSIGNCHAR i,UNSIGNCHAR j,UNSIGNCHAR quartet1[4], UNSIGNCHAR quartet2[4]);
  void DisplayMatrix(int **m);

  int GenUltra(UNSIGNCHAR *line, int bracketlabel,int internalindex);
  void merge(int *dest, int *source);
  void merge(int *dest, int number);
  void  AddConflict(UNSIGNCHAR *q1,UNSIGNCHAR *q2,UNSIGNCHAR *q3);
};
#endif


